First Bad Version
You are a product manager and currently leading a team to develop a new product. Unfortunately, the latest version of your product fails the quality check. Since each version is developed based on the previous version, all the versions after a bad version are also bad.
Suppose you have n versions [1, 2, ..., n] and you want to find out the first bad one, which causes all the following ones to be bad.
You are given an API bool isBadVersion(version) which returns whether version is bad. Implement a function to find the first bad version. You should minimize the number of calls to the API.
Example 1:
Input: n = 5, bad = 4
Output: 4
Explanation:
call isBadVersion(3) -> false
call isBadVersion(5) -> true
call isBadVersion(4) -> true
Then 4 is the first bad version.
Example 2:
Input: n = 1, bad = 1
Output: 1
Constraints:
1 <= bad <= n <= 231 - 1
思路一:二分法,因为此题的二分查找里面没有相等的判断条件,所以需要变通一下。看了一下题解,有更好的优化判断
public int firstBadVersion(int n) {
int high = n;
int low = 1;
while (high > low) {
int mid = (high + low) >>> 1;
boolean bool = isBadVersion(mid);
if (bool) {
high = mid - 1;
if (!isBadVersion(high)) return mid;
} else {
low = mid + 1;
if (isBadVersion(low)) return low;
}
}
return 1;
}
public static int firstBadVersion(int n) {
int high = n;
int low = 1;
while (high > low) {
int mid = (high + low) >>> 1;
boolean bool = isBadVersion(mid);
if (bool) {
high = mid;
} else {
low = mid;
}
}
return high;
}
标签:int,mid,high,bad,version,low,easy,278,leetcode
From: https://www.cnblogs.com/iyiluo/p/16845751.html